#include <acl.c>
#include "tl9builtin.c"

#ifdef AUSE_HLX
	regVarOpt(0, zx, zy, xx, yy, cx, cy, n, sn);	// for spd.
	regVarOpt(1, n, zx, zy, x, y, sy, sx, c, sn);	// for siz.
#endif

void aMain()
{
    AWindow *w;
    int x, y, sx, sy, cx, cy, zx, zy, xx, yy, t, n, sn, c;
    w = aOpenWin(512, 384, "mandel", 1);
    for (y = 0; y < 384; y++) {
        for (x = 0; x < 512; x++) {
            sn = 0;
            for (sx = 0; sx < 4; sx++) {
                cx = (x * 4 + sx) * 56 + 4673536;
                for (sy = 0; sy < 4; sy++) {
                    cy = (y * 4 + sy) * -56 - 124928;
                    zx = cx; zy = cy;
                    for (n = 1; n < 447; n++) {
                        xx = mul64shr(zx, zx, 24);
                        yy = mul64shr(zy, zy, 24);
                        if (xx + yy > 0x4000000) break;
                        zy = mul64shr(zy, zx, 23);
                        zx = xx + cx;
                        zy = zy + cy;
                        zx = zx - yy;
                    }
                    sn = sn + n;
                }
            }
            n = sn >> 4;
            c = aRgb8(n, 0, 0);
            if (n > 255) {
                c = aRgb8(0, 0, 0);
                if (n != 447) {
                    c = aRgb8(255, n - 255, 0);
                }
            }
            aSetPix0(w, x, y, c);
        }
    }
    printTime();
    aWait(-1);
}
